package com.retail_store.order_management.model;

import java.time.LocalDate;
import java.time.LocalTime;
import java.util.Arrays;
import java.util.List;
import java.util.UUID;

public class Order {
    private String orderId;
    private LocalDate orderDate;
    private LocalTime localTime;
    private String customerName;
    private String phoneNumber;
    private double totalBill;
    List<OrderedProduct> productsList;

    public Order(String orderId, LocalDate orderDate, LocalTime localTime, String customerName, String phoneNumber, double totalBill, List<OrderedProduct> productsList) {
        this.orderId = orderId;
        this.orderDate = orderDate;
        this.localTime = localTime;
        this.customerName = customerName;
        this.phoneNumber = phoneNumber;
        this.totalBill = totalBill;
        this.productsList = productsList;
    }

    public String getOrderId() {
        return orderId;
    }

    public LocalDate getOrderDate() {
        return orderDate;
    }

    public LocalTime getLocalTime() {
        return localTime;
    }

    public String getCustomerName() {
        return customerName;
    }

    public String getPhoneNumber() {
        return phoneNumber;
    }

    public double getTotalBill() {
        return totalBill;
    }

    public List<OrderedProduct> getProductsList() {
        return productsList;
    }


    public String showOrder() {
        return "order id : " + orderId + "\nCustomer name: " + customerName + "\tPhone number: " + phoneNumber + "\nDate: " + orderDate + "\tTime: " + localTime + "\n Total Bill: " + totalBill;
    }

    public String showProducts() {
        return productsList.stream().map(product -> product.getId() + "\t" + product.getName() + "\n" + product.getCategory() + "\t" + product.getSize() + "\n" + product.getQuantity() + "\t" + product.getPrice() + "\t" + product.getQuantity() * product.getPrice()).reduce("", (productsList, product) -> productsList + "\n" + product);
    }

    public String orderIdGenerator() {
        return Arrays.stream(UUID.randomUUID().toString().split("-")).findFirst().get() + "#" + Order.class.getSimpleName();
    }
}
