package com.retail_store.order_management.model;


import com.retail_store.order_management.constants.Category;
import com.retail_store.order_management.constants.Color;
import com.retail_store.order_management.constants.Gender;
import com.retail_store.order_management.constants.Size;

public class OrderedProduct {
    private String id;
    private String name;
    private Category category;
    private Color color;
    private double price;
    private Gender idealFor;
    private Size size;
    private int quantity;

    public String getId() {
        return id;
    }

    public String getName() {
        return name;
    }

    public Category getCategory() {
        return category;
    }

    public Color getColor() {
        return color;
    }

    public double getPrice() {
        return price;
    }

    public Gender getIdealFor() {
        return idealFor;
    }

    public Size getSize() {
        return size;
    }

    public int getQuantity() {
        return quantity;
    }

    public OrderedProduct(String id, String name, Category category, Color color, double price, Gender idealFor, Size size, int quantity) {
        this.id = id;
        this.name = name;
        this.category = category;
        this.color = color;
        this.price = price;
        this.idealFor = idealFor;
        this.size = size;
        this.quantity = quantity;
    }

    @Override
    public String toString() {
        return "OrderedProduct{" +
                "id='" + id + '\t' +
                ", name='" + name + '\n' +
                ", category=" + category + '\t' +
                ", color=" + color + '\n' +
                ", price=" + price + '\t' +
                ", idealFor=" + idealFor + '\n' +
                ", size=" + size + '\t' +
                ", quantity=" + quantity +
                '}';
    }
}
